/*
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this code; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  */

/* Copyright (C) 2002 Ian Zimmerman <itz@speakeasy.org> */

static const char rcsid[] = "$Id: show_dialog.cc,v 1.2 2002/09/09 21:28:08 itz Exp itz $ ";

#include "show_dialog.hh"

// g++ 2.x is nonstandard, sigh
#if (defined(__GNUG__) && (__GNUG__ < 3))
#include <strstream>
typedef ostrstream ostringstream;
#else
#include <sstream>
#endif

#include <iomanip>

#include <gtk--/button.h>
#include <gtk--/entry.h>
#include <gtk--/box.h>
#include <gtk/gtkmain.h>
#include <gdk/gdk.h>

void
show_dialog::ok_handler()
{
  set_modal(0);
  destroy();
}

void
show_dialog::copy_handler()
{
  p_entry->copy_clipboard();
}

show_dialog::show_dialog(gdouble red, gdouble green, gdouble blue)
  : Gtk::Dialog()
{
  ostringstream rgbi;
  
  Gtk::HBox* p_action = get_action_area();
  Gtk::VBox* p_vbox = get_vbox();
  Gtk::HBox* p_hbox = manage(new Gtk::HBox(0, 10));

  p_entry = manage(new Gtk::Entry);
  rgbi << "rgb:" << hex << setfill('0')
       << setw(4) << (int)(red * 65535) << '/'
       << setw(4) << (int)(green * 65535) << '/'
       << setw(4) << (int)(blue * 65535) << '\0';
  p_entry->set_text(rgbi.str());
  p_entry->select_region(0, -1);
  p_hbox->pack_start(*p_entry, 0, 0, 5);
  p_vbox->pack_start(*p_hbox, 0, 0, 5);

  Gtk::Button* p_copy = manage(new Gtk::Button("Copy"));
  Gtk::Button* p_ok = manage(new Gtk::Button("Ok"));
  p_action->pack_start(*p_copy);
  p_action->pack_start(*p_ok);
  p_copy->clicked.connect(SigC::slot(this, &show_dialog::copy_handler));
  p_ok->clicked.connect(SigC::slot(this, &show_dialog::ok_handler));

  // it's better to leave this up to the window manager
  //  set_position(GTK_WIN_POS_CENTER);
  show_all();  
  p_ok->grab_focus();
  set_modal(1);
}
